require "defines"

limitizer_debug = false

				

game.oninit(function()
initialization()
	
 end)
 
game.onload (function()
initialization()

end)

game.onevent(defines.events.onbuiltentity, function(event) 

	--game.player.print(event.createdentity.name)
	local x1,y1
	x1, y1 = string.find(event.createdentity.name, "powerlimitizer")
			
	if x1 ~= nil then
		glob.limitizer[#glob.limitizer+1] = event.createdentity										
		glob.limitizer.limit[#glob.limitizer] = 0	
	end
	
	
	local x1,y1
	x1, y1 = string.find(event.createdentity.name, "dmg")
			
	if x1 ~= nil then
		glob.dmg[#glob.dmg+1] = event.createdentity										
	end
	
end)


game.onevent(defines.events.onplayermineditem, function(event)

	local x1,y1
	x1, y1 = string.find(event.itemstack.name, "powerlimitizer")	
	
	if x1 ~= nil then
		
		for k, limitizer in ipairs(glob.limitizer) do
			if not limitizer.valid then
				
				if k == glob.menulimdevnum then
					if game.player.gui.left.menu_lim ~= nil then game.player.gui.left.menu_lim.destroy() end
					if game.player.gui.left.menu_lim_small ~= nil then game.player.gui.left.menu_lim_small.destroy() end
				end
				
				if k < glob.menulimdevnum then
					glob.menulimdevnum = glob.menulimdevnum - 1
				end
				
				table.remove(glob.limitizer, k)
				table.remove(glob.limitizer.limit, k)
				
			end
		end
		
	end
	
	local x1,y1
	x1, y1 = string.find(event.itemstack.name, "dmg")	
	
	if x1 ~= nil then
		
		for k, dmg in ipairs(glob.dmg) do
			if not dmg.valid then
				
				if k == glob.menulimdevnum then
					if game.player.gui.left.menu_lim ~= nil then game.player.gui.left.menu_lim.destroy() end
					if game.player.gui.left.menu_lim_small ~= nil then game.player.gui.left.menu_lim_small.destroy() end
				end
				
				table.remove(glob.dmg, k)
				
			end
		end
		
	end
	
	
	
end)


game.onevent(defines.events.onentitydied, function(event)

	--glob.teledied = true
	--glob.telediedname = event.entity.name
	--glob.telediedposition.x = event.entity.position.x
	--glob.telediedposition.y = event.entity.position.y

end)


game.onevent(defines.events.onguiclick, function(event)  --on click events
	
	if event.element.name == "limdec" then
		glob.stop_ref_guilim_1 = false
		if glob.limitizer.limit[glob.menulimdevnum]-1 >= 0 then 
			glob.limitizer.limit[glob.menulimdevnum] = glob.limitizer.limit[glob.menulimdevnum] - 1
		end
	end
	
	if event.element.name == "liminc" then
		glob.stop_ref_guilim_1 = false
		if glob.limitizer.limit[glob.menulimdevnum] +1 <= 500 then 
			glob.limitizer.limit[glob.menulimdevnum] = glob.limitizer.limit[glob.menulimdevnum] + 1
		end
	end	
	
	if event.element.name == "limtxtfield2" then
		glob.stop_ref_guilim_1 = true
	end
	
	if event.element.name == "limset" then
		glob.stop_ref_guilim_1 = false
		if tonumber(game.player.gui.left.menu_lim.rowlim_2.limtxtfield2.text) ~= nil then
			local number = (tonumber(game.player.gui.left.menu_lim.rowlim_2.limtxtfield2.text)/10)
			if (number*10)%10 ~= 0 then number = math.floor(number) end
			if number < 0 then number = 0 end
			if number > 500 then number = 500 end
			glob.limitizer.limit[glob.menulimdevnum] = number
		end
	end	
	
	if event.element.name == "CheckBox_lim_1" then
		if game.player.gui.left.menu_lim_small.rowlim_2.CheckBox_lim_1.state == false then glob.creategui2_lim = true end
		if game.player.gui.left.menu_lim_small.rowlim_2.CheckBox_lim_1.state == true then glob.creategui2_lim = false end
	end
	
	if event.element.name == "button_lim_close" then
		if game.player.gui.left.menu_lim ~= nil then game.player.gui.left.menu_lim.destroy() end
		if game.player.gui.left.menu_lim_small ~= nil then game.player.gui.left.menu_lim_small.destroy() end
		glob.menulimdevnum = 0
	end
	
	
end)

game.onevent(defines.events.ontick, function(event)
	timerlimit()
		--game.player.clearconsole()
		--game.player.print("timer 1: " .. glob.limtimer[1])
		--game.player.print("timer 2: " .. glob.limtimer[2])

		--game.player.print("limitizers:  " .. #glob.limitizer)
		--game.player.print("limit  " .. #glob.limitizer.limit)
		--game.player.print("dmg  " .. #glob.dmg)
		
		
	if glob.limtimer[1]>=60 then
		glob.limtimer[1]=0
		
		local selecteddevice = false
		
		if game.player.selected ~= nil then
			local x1,y1
			x1, y1 = string.find(game.player.selected.name, "powerlimitizer")
		
			if x1 ~= nil then
				selecteddevice = true
			end
			
		end
				
		if game.player.selected ~= nil and selecteddevice == true then
			if game.player.gui.left.menu_lim==nil then
				--game.player.print("no i wlazł cwaniak jeden 11111  " .. #glob.limitizer)	
				for k, limitizer in ipairs(glob.limitizer) do
					if limitizer.valid then
							
						if (game.player.selected.position.x == glob.limitizer[k].position.x) and (game.player.selected.position.y == glob.limitizer[k].position.y) then
							--game.player.print("no i wlazł cwaniak jeden 22222    k=" .. k)
							glob.menulimdevnum = k
							
							if game.player.gui.left.menu_lim==nil then
							
								createtelegui()
								if glob.creategui2_lim == true then
									if game.player.gui.left.menu_lim_small == nil then createtelegui2() end
								end
								
							end	

						end

					end
				end
			end
		end
		
	end	
	

	
--[[	if glob.limtimer[2]>=500 then -- copier from tleinserter
		--game.player.print("t2   " .. glob.teletimer[2])
		glob.limtimer[2]=0
		--game.player.print("tutaj wylacza 2222222222222222222222222222222222222222222222222222222222222222222222222222222")
		glob.timer2start = false
		glob.conncetingdevice = false
		if game.player.gui.left.menu_lim ~= nil then game.player.gui.left.menu_lim.rowtele_1.cto.caption="Connect to output" end
		if game.player.gui.left.menu_lim ~= nil then game.player.gui.left.menu_lim.rowtele_1.cto.style.fontcolor = {r = 1, g = 1, b = 1} end
	end]]--
	


	if game.tick%10==0 then -- aktualizacja danych w menu
		if game.player.gui.left.menu_lim ~= nil then
			
			if not glob.stop_ref_guilim_1 then game.player.gui.left.menu_lim.rowlim_2.limtxtfield2.caption = (glob.limitizer.limit[glob.menulimdevnum])*10 end
			game.player.gui.left.menu_lim.rowlim_3.label_menulim_3_1.caption="Current power limit: " .. (glob.limitizer.limit[glob.menulimdevnum])*10 .. "kW"
			game.player.gui.left.menu_lim.rowlim_4.label_menulim_4_1.caption="Current device energy: " .. math.floor(glob.limitizer[glob.menulimdevnum].energy/1000) .. "kJ"
			
		end
	end


	if game.tick%1==0 then -- podmienianie limiterow w zaleznosci od wartosciw  tabeli
		local name_buf = "powerlimitizer"
		for k, limitizer in ipairs(glob.limitizer) do
			if limitizer.valid then
				local name = ""
				if glob.limitizer.limit[k] > 0 then name = name_buf .. "-" .. glob.limitizer.limit[k] end
				if glob.limitizer.limit[k] == 0 then name = name_buf end
				
				--game.player.print(glob.limitizer.limit[k] .. "   " .. glob.limitizer[k].name .. "  " .. name)
				
				if glob.limitizer[k].name ~= name then
			
					local pos_x = glob.limitizer[k].position.x
					local pos_y = glob.limitizer[k].position.y
					local buf_energy = glob.limitizer[k].energy
					
					glob.limitizer[k].destroy()
					glob.limitizer[k] = game.createentity{name = name, position= {pos_x, pos_y}, force=game.forces.player}
					glob.limitizer[k].energy = buf_energy
					
				end
				
			end
		end
		
		
	end

	
	if game.tick%1==0 then -- działania własciwe dmg
		for k, dmg in ipairs(glob.dmg) do
			if dmg.valid then
				glob.dmg[k].energy = 200000
			end
		end		
	end
	
	if game.tick%60==0 then -- poluttion dla dmg
		for k, dmg in ipairs(glob.dmg) do
			if dmg.valid then
				game.pollute(glob.dmg[k].position, 5)
				--game.player.print("add pollute")
			end
		end		
	end
	

end)

function initialization()

	if glob.limtimer == nil then
		glob.limtimer = {0,0}											
	end
	
	if glob.limtimer2start == nil then
		glob.limtimer2start = false								
	end	
	
	if glob.limitizer == nil then
		glob.limitizer = {}											
	end
	
	if glob.limitizer.limit == nil then
		glob.limitizer.limit = {}											
	end
	
	if glob.menulimdevnum == nil then
		glob.menulimdevnum = 0										
	end

	if glob.stop_ref_guilim_1 == nil then
		glob.stop_ref_guilim_1 = false									
	end
	
	if glob.dmg == nil then
		glob.dmg = {}									
	end

	if glob.creategui2_lim == nil then
		glob.creategui2_lim = true									
	end
	
end



function createtelegui()  -- pozmienieaj nazwy wszystkiego bo sa takie same jak w teleinserterach

	game.player.gui.left.add({type="frame", name="menu_lim", caption="  Power Limiter Settings",direction="vertical"})
	
	--game.player.gui.left.menu_lim.add({type="flow",name="row_0",direction="horizontal"})
	--game.player.gui.left.menu_lim.row_0.add({type="checkbox", name="checkbox_0_1", caption="Input",state=true})
	--game.player.gui.left.menu_lim.row_0.add({type="checkbox", name="checkbox_0_2", caption="Output",state=false})
	game.player.gui.left.menu_lim.add({type="flow",name="rowlim_0",direction="horizontal"})
	
	game.player.gui.left.menu_lim.add({type="flow",name="rowlim_1",direction="horizontal"})
	game.player.gui.left.menu_lim.rowlim_1.add({type="button", name="limdec", caption=" - "})--, style="lim_inv_button"})
	--game.player.gui.left.menu_lim.rowlim_1.add({type="textfield", name="limtxtfield1", caption=""})
	game.player.gui.left.menu_lim.rowlim_1.add({type="button", name="liminc", caption=" + "})--, style="lim_inv_button"})
	--game.player.gui.left.menu_lim.rowlim_1.add({type="button", name="af", caption="Apply filter"})	
		mw = 96
		game.player.gui.left.menu_lim.rowlim_1.liminc.style.maximalwidth=mw
		game.player.gui.left.menu_lim.rowlim_1.liminc.style.minimalwidth=mw
		game.player.gui.left.menu_lim.rowlim_1.limdec.style.maximalwidth=mw
		game.player.gui.left.menu_lim.rowlim_1.limdec.style.minimalwidth=mw		
	
	game.player.gui.left.menu_lim.add({type="flow",name="blank1",direction="horizontal"})
		
	game.player.gui.left.menu_lim.add({type="flow",name="rowlim_2",direction="horizontal"})
	--game.player.gui.left.menu_lim.rowlim_2.add({type="label", name="label_menulim_2_0", caption="", style="caption_label_style_lim_label"})
	--game.player.gui.left.menu_lim.rowlim_2.add({type="label", name="label_menulim_2_1", caption="Connected to:", style="caption_label_style_lim_label"})
	game.player.gui.left.menu_lim.rowlim_2.add({type="textfield", name="limtxtfield2", caption="", style="lim_textfield_style"})
	game.player.gui.left.menu_lim.rowlim_2.add({type="button", name="limset", caption="SET", style="lim_inv_button"})
		--game.player.gui.left.menu_lim.rowlim_2.label_menulim_2_1.style.font="default-bold"
		--game.player.gui.left.menu_lim.rowlim_2.label_menulim_2_1.style.minimalwidth=85
		--game.player.gui.left.menu_lim.rowlim_2.label_menulim_2_0.style.minimalwidth=160
	
	game.player.gui.left.menu_lim.add({type="flow",name="blank2",direction="horizontal"})
			
	game.player.gui.left.menu_lim.add({type="flow",name="rowlim_3",direction="vertical"})
	game.player.gui.left.menu_lim.rowlim_3.add({type="label", name="label_menulim_3_1", caption="Current power limit:", style="caption_label_style_lim_label"})
		
	game.player.gui.left.menu_lim.add({type="flow",name="rowlim_4",direction="vertical"})
	game.player.gui.left.menu_lim.rowlim_4.add({type="label", name="label_menulim_4_1", caption="Current device energy:", style="caption_label_style_lim_label"})		
		
	game.player.gui.left.menu_lim.add({type="flow",name="rowlim_end",direction="horizontal"})
	game.player.gui.left.menu_lim.rowlim_end.add({type="button", name="button_lim_close", caption="SAVE AND CLOSE"})
		game.player.gui.left.menu_lim.rowlim_end.button_lim_close.style.font="default-bold"
		mw=200
		game.player.gui.left.menu_lim.rowlim_end.button_lim_close.style.maximalwidth=mw
		game.player.gui.left.menu_lim.rowlim_end.button_lim_close.style.minimalwidth=mw
		
end

function createtelegui2()  -- pozmienieaj nazwy wszystkiego bo sa takie same jak w teleinserterach

	game.player.gui.left.add({type="frame", name="menu_lim_small", caption="Info Box",direction="vertical"})
	
	game.player.gui.left.menu_lim_small.add({type="flow",name="rowlim_1",direction="vertical"})
	game.player.gui.left.menu_lim_small.rowlim_1.add({type="label", name="label_menulim_1s_1", caption="• Power is in kW", style="lim_label_style"})
	game.player.gui.left.menu_lim_small.rowlim_1.add({type="label", name="label_menulim_1s_2", caption="• +/- add or subtract 10kW", style="lim_label_style"})
	game.player.gui.left.menu_lim_small.rowlim_1.add({type="label", name="label_menulim_1s_3", caption="• Maximum power limit is 5000kW = 5MW", style="lim_label_style"})
	game.player.gui.left.menu_lim_small.rowlim_1.add({type="label", name="label_menulim_1s_4", caption="• Minimum power limit is 0W - it act as a simple ON/OFF switch", style="lim_label_style"})
	game.player.gui.left.menu_lim_small.rowlim_1.add({type="label", name="label_menulim_1s_5", caption="• Only multiple of 10kW is allowed", style="lim_label_style"})	
	game.player.gui.left.menu_lim_small.add({type="flow",name="blank1",direction="vertical"})
	game.player.gui.left.menu_lim_small.add({type="flow",name="rowlim_2",direction="vertical"})
	game.player.gui.left.menu_lim_small.rowlim_2.add({type="checkbox", name="CheckBox_lim_1", caption="Check me and Info Box will never be displayed again", state=false})
end

function timerlimit()
-- timer generation


-- new timer generation
--local sellectedins = false
	if game.player.selected ~= nil then
		local x1,y1
		x1, y1 = string.find(game.player.selected.name, "powerlimitizer")
		
		--game.player.print(game.player.selected.name)
		
		if x1 ~= nil then
			glob.limtimer[1]=glob.limtimer[1]+1
			
			--sellectedlim = true
			glob.limtimer[2]=0
			
			--game.player.print("timer 1 " .. glob.teletimer[1])
		else
			--if glob.limtimer2start == true then glob.limtimer[2]=glob.limtimer[2]+1 end
		end
	else
		--if glob.limtimer2start == true then glob.limtimer[2]=glob.limtimer[2]+1 end -- jesli selected = nil
	end

	
	--if game.player.selected == nil or sellectedlim == false then
	if game.player.selected == nil then
		--game.player.print("tu tut 22")
		--if glob.timer2start == true then game.player.print("true") else game.player.print("false") end
		glob.limtimer[1]=0
		--sellectedins = nil
	end
--new end timer generation

end
