data:extend(
{

  {
    type = "technology",
    name = "powerlimitizer",
    icon = "__Powerlimiter__/graphics/icons/powerlimitizer.png",
    effects =
    {
      {type = "unlock-recipe", recipe = "powerlimitizer"}
    },
    prerequisites = {"electric-energy-accumulators-1", "electric-energy-distribution-2"},
    unit =
    {
      count = 250,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1}
      },
      time = 10
    },
    order = "c-e-a",
  },
  {
    type = "technology",
    name = "dmg",
    icon = "__Powerlimiter__/graphics/icons/dmg.png",
    effects =
    {
      {type = "unlock-recipe", recipe = "dmg"}
    },
    prerequisites = {"powerlimitizer"},
    unit =
    {
      count = 1000,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1}
      },
      time = 5
    },
    order = "c-e-a",
  },
  {
    type = "technology",
    name = "dmg2",
    icon = "__Powerlimiter__/graphics/icons/dmg2.png",
    effects =
    {
      {type = "unlock-recipe", recipe = "dmg2"}
    },
    prerequisites = {"dmg"},
    unit =
    {
      count = 2000,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1}
      },
      time = 5
    },
    order = "c-e-a",
  },
    {
    type = "technology",
    name = "dmg3",
    icon = "__Powerlimiter__/graphics/icons/dmg3.png",
    effects =
    {
      {type = "unlock-recipe", recipe = "dmg3"}
    },
    prerequisites = {"dmg2"},
    unit =
    {
      count = 4000,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1}
      },
      time = 5
    },
    order = "c-e-a",
  }
}
)