local lim_inv_button=
    {
      type = "button_style",
      font = "default-button",
      minimal_width = 1,
      minimal_height = 1,
	  --hovered_font_color = {r=0, g=0, b=0},
      default_font_color={r=1, g=1, b=1},
      align = "center",
      top_padding = 0,
      right_padding = 1,
      bottom_padding = 0,
      left_padding = 1,
      default_graphical_set =
      {
        type = "composition",
        filename = "__Powerlimiter__/graphics/gui/inv.png",
        corner_size = {3, 3},
        position = {0, 0}
      },
      hovered_font_color={r=0.349019608, g=0.584313725, b=0.968627451}, 
      hovered_graphical_set =
      {
        type = "composition",
        filename = "__Powerlimiter__/graphics/gui/inv.png",
        corner_size = {3, 3},
        position = {0, 8}
      },
      clicked_font_color={r=1, g=1, b=1},
      clicked_graphical_set =
      {
        type = "composition",
        filename = "__Powerlimiter__/graphics/gui/inv.png",
        corner_size = {3, 3},
        position = {0, 16}
      },
      pie_progress_color = {r=1, g=1, b=1}
    }

local lim_textfield_style=
    {
      type = "textfield_style",
      left_padding = 3,
      right_padding = 2,
      minimal_width = 150,
      font = "default",
      font_color = {},
	  align = "center",
      graphical_set =
      {
        type = "composition",
        filename = "__core__/graphics/gui.png",
        corner_size = {3, 3},
        position = {16, 0}
      },
      selection_background_color= {r=0.66, g=0.7, b=0.83}
    }

local lim_label_style =
    {
      type = "label_style",
      font = "default",
      font_color = {r=1, g=1, b=1},
	  --maximal_height = 5,
	  --maximalheight = 5,
	 -- minimal_height = 5,
	 -- minimalheight = 5
    }


data.raw["gui-style"].default["lim_inv_button"] = lim_inv_button
data.raw["gui-style"].default["lim_textfield_style"] = lim_textfield_style
data.raw["gui-style"].default["lim_label_style"] = lim_label_style